--- a/zipl/src/job.c
+++ b/zipl/src/job.c
@@ -50,11 +50,12 @@ static struct option options[] = {
 	{ "tape",		required_argument,	NULL, 'T'},
 	{ "dry-run",		no_argument,		NULL, '0'},
 	{ "force",		no_argument,		NULL, 'f'},
+	{ "kdump",		required_argument,	NULL, 'k'},
 	{ NULL,			0,			NULL, 0 }
 };
 
 /* Command line option abbreviations */
-static const char option_string[] = "-c:t:i:r:p:P:d:D:M:s:m:hHnVvaT:f";
+static const char option_string[] = "-c:t:i:r:p:P:d:D:M:s:m:hHnVvaT:fk:";
 
 struct command_line {
 	char* data[SCAN_KEYWORD_NUM];
@@ -109,9 +110,9 @@ get_command_line(int argc, char* argv[],
 					  optarg);
 			break;
 		case 'D':
-			is_keyword = 1;
-			rc = store_option(&cmdline, scan_keyword_dumptofs,
-					  optarg);
+			error_reason("dumptofs has been deprecated, use "
+				     "--dump instead");
+			rc = -1;
 			break;
 		case 'M':
 			is_keyword = 1;
@@ -183,6 +184,11 @@ get_command_line(int argc, char* argv[],
 			rc = store_option(&cmdline, scan_keyword_tape,
 					  optarg);
 			break;
+		case 'k':
+			is_keyword = 1;
+			rc = store_option(&cmdline, scan_keyword_kdump,
+					  optarg);
+			break;
 		case 'c':
 			if (cmdline.config != NULL) {
 				error_reason("Option 'config' specified more "
@@ -337,10 +343,10 @@ free_segment_data(struct job_segment_dat
 
 
 static void
-free_dump_fs_data(struct job_dump_fs_data* data)
+free_dump_data(struct job_dump_data* data)
 {
-	if (data->partition != NULL)
-		free(data->partition);
+	if (data->device != NULL)
+		free(data->device);
 	if (data->image != NULL)
 		free(data->image);
 	if (data->parmline != NULL)
@@ -363,9 +369,9 @@ free_menu_data(struct job_menu_data* dat
 			case job_ipl:
 				free_ipl_data(&data->entry[i].data.ipl);
 				break;
-			case job_dump_fs:
-				free_dump_fs_data(
-					&data->entry[i].data.dump_fs);
+			case job_dump_partition:
+				free_dump_data(
+					&data->entry[i].data.dump);
 				break;
 			default:
 				break;
@@ -377,14 +383,6 @@ free_menu_data(struct job_menu_data* dat
 
 
 void
-free_dump_data(struct job_dump_data* data)
-{
-	if (data->device != NULL)
-		free(data->device);
-}
-
-
-void
 free_mvdump_data(struct job_mvdump_data* data)
 {
 	int i;
@@ -421,9 +419,6 @@ job_free(struct job_data* job)
 	case job_mvdump:
 		free_mvdump_data(&job->data.mvdump);
 		break;
-	case job_dump_fs:
-		free_dump_fs_data(&job->data.dump_fs);
-		break;
 	case job_ipl_tape:
 		free_ipl_tape_data(&job->data.ipl_tape);
 		break;
@@ -534,7 +529,7 @@ error:
 
 
 static int
-get_dump_fs_components(struct job_dump_fs_data *dump_fs,
+get_dump_components(struct job_dump_data *dump,
 		       struct component_loc **clp, int *nump)
 {
 	struct component_loc *cl;
@@ -547,19 +542,19 @@ get_dump_fs_components(struct job_dump_f
 		return -1;
 	/* Fill in component data */
 	num = 0;
-	rc = set_cl_element(&cl[num++], "kernel image", dump_fs->image,
-			    &dump_fs->image_addr, 0, 0x10000,
+	rc = set_cl_element(&cl[num++], "kernel image", dump->image,
+			    &dump->image_addr, 0, 0x10000,
 			    MAXIMUM_PHYSICAL_BLOCKSIZE);
 	if (rc)
 		goto error;
-	rc = set_cl_element(&cl[num++], "parmline", NULL, &dump_fs->parm_addr,
+	rc = set_cl_element(&cl[num++], "parmline", NULL, &dump->parm_addr,
 			    MAXIMUM_PARMLINE_SIZE, 0,
 			    MAXIMUM_PHYSICAL_BLOCKSIZE);
 	if (rc)
 		goto error;
-	if (dump_fs->ramdisk) {
+	if (dump->ramdisk) {
 		rc = set_cl_element(&cl[num++], "initial ramdisk",
-				    dump_fs->ramdisk, &dump_fs->ramdisk_addr,
+				    dump->ramdisk, &dump->ramdisk_addr,
 				    0, 0, 0x10000);
 		if (rc)
 			goto error;
@@ -619,7 +614,8 @@ error:
 
 
 static int
-check_component_address_data(struct component_loc *cl, int num, char *name)
+check_component_address_data(struct component_loc *cl, int num, char *name,
+			     unsigned long address_limit)
 {
 	int i;
 
@@ -627,12 +623,12 @@ check_component_address_data(struct comp
 	for (i = 0; i < num; i++) {
 		if (*cl[i].addrp == UNSPECIFIED_ADDRESS)
 			continue;
-		if (*cl[i].addrp + cl[i].size > ADDRESS_LIMIT) {
+		if (*cl[i].addrp + cl[i].size > address_limit) {
 			if (name != NULL)
 				error_text("Section '%s'", name);
 			error_reason("Component '%s' exceeds available address "
 				     "space (limit is 0x%08x)", cl[i].name,
-				     ADDRESS_LIMIT);
+				     address_limit);
 			return -1;
 		}
 		if (*cl[i].addrp < MINIMUM_ADDRESS) {
@@ -662,7 +658,8 @@ check_component_address_data(struct comp
 
 
 static int
-finalize_component_address_data(struct component_loc *cl, int num)
+finalize_component_address_data(struct component_loc *cl, int num,
+				unsigned long address_limit)
 {
 	struct component_loc swap;
 	address_t addr;
@@ -685,7 +682,7 @@ finalize_component_address_data(struct c
 					addr = MINIMUM_ADDRESS;
 			}
 			addr = ALIGN(addr, cl[i].align);
-			if (addr + cl[i].size > ADDRESS_LIMIT) {
+			if (addr + cl[i].size > address_limit) {
 				error_text("Could not fit component '%s' into "
 					   "available address space",
 					   cl[i].name);
@@ -715,18 +712,20 @@ finalize_component_address_data(struct c
 static int
 finalize_ipl_address_data(struct job_ipl_data* ipl, char *name)
 {
+	unsigned long address_limit;
 	struct component_loc *cl;
 	int num;
 	int rc;
 
+	address_limit = ipl->is_kdump ? ADDRESS_LIMIT_KDUMP : ADDRESS_LIMIT;
 	rc = get_ipl_components(ipl, &cl, &num);
 	if (rc)
 		return rc;
 	sort_cl_array(cl, num);
-	rc = check_component_address_data(cl, num, name);
+	rc = check_component_address_data(cl, num, name, address_limit);
 	if (rc)
 		goto out_free;
-	rc = finalize_component_address_data(cl, num);
+	rc = finalize_component_address_data(cl, num, address_limit);
 out_free:
 	free(cl);
 	return rc;
@@ -734,20 +733,20 @@ out_free:
 
 
 static int
-finalize_dump_fs_address_data(struct job_dump_fs_data* dump_fs, char *name)
+finalize_dump_address_data(struct job_dump_data* dump, char *name)
 {
 	struct component_loc *cl;
 	int num;
 	int rc;
 
-	rc = get_dump_fs_components(dump_fs, &cl, &num);
+	rc = get_dump_components(dump, &cl, &num);
 	if (rc)
 		return rc;
 	sort_cl_array(cl, num);
-	rc = check_component_address_data(cl, num, name);
+	rc = check_component_address_data(cl, num, name, ADDRESS_LIMIT);
 	if (rc)
 		goto out_free;
-	rc = finalize_component_address_data(cl, num);
+	rc = finalize_component_address_data(cl, num, ADDRESS_LIMIT);
 out_free:
 	free(cl);
 	return rc;
@@ -766,10 +765,10 @@ finalize_ipl_tape_address_data(struct jo
 	if (rc)
 		return rc;
 	sort_cl_array(cl, num);
-	rc = check_component_address_data(cl, num, name);
+	rc = check_component_address_data(cl, num, name, ADDRESS_LIMIT);
 	if (rc)
 		goto out_free;
-	rc = finalize_component_address_data(cl, num);
+	rc = finalize_component_address_data(cl, num, ADDRESS_LIMIT);
 	/* The loader needs a ramdisk_addr anyway */
 	if (ipl_tape->ramdisk_addr == 0) {
 		for (i = 0; i < num; i++) {
@@ -860,50 +859,34 @@ check_job_dump_data(struct job_dump_data
 }
 
 
-static int
-check_job_dump_fs_data(struct job_dump_fs_data* dump_fs, char* name)
+int
+check_job_dump_images(struct job_dump_data* dump, char* name)
 {
 	int rc;
-
-	if (dump_fs->partition != NULL) {
-		rc = misc_check_writable_device(dump_fs->partition, 1, 0);
-		if (rc) {
-			if (name == NULL) {
-				error_text("Dump partition '%s'",
-					dump_fs->partition);
-			} else {
-				error_text("Dump partition '%s' in "
-					"section '%s'", dump_fs->partition,
-					name);
-			}
-			return rc;
-		}
-	}
-
 	/* Add data needed to convert fs dump job to IPL job */
-	rc = misc_check_readable_file(FSDUMP_IMAGE);
+	rc = misc_check_readable_file(FSDUMP_PART_IMAGE);
 	if (rc) {
-		error_text("Need external file '%s' for file system dump",
-			   FSDUMP_IMAGE);
+		error_text("Need external file '%s' for partition dump",
+			   FSDUMP_PART_IMAGE);
 		return rc;
 	}
-	dump_fs->image = misc_strdup(FSDUMP_IMAGE);
-	if (dump_fs->image == NULL)
+	dump->image = misc_strdup(FSDUMP_PART_IMAGE);
+	if (dump->image == NULL)
 		return -1;
-	dump_fs->image_addr = DEFAULT_IMAGE_ADDRESS;
+	dump->image_addr = DEFAULT_IMAGE_ADDRESS;
 
 	/* Ramdisk is no longer required with new initramfs dump system */
-	if (misc_check_readable_file(FSDUMP_RAMDISK))
-		dump_fs->ramdisk = NULL;
+	if (misc_check_readable_file(FSDUMP_PART_RAMDISK))
+		dump->ramdisk = NULL;
 	else {
-		dump_fs->ramdisk = misc_strdup(FSDUMP_RAMDISK);
-		if (dump_fs->ramdisk == NULL)
+		dump->ramdisk = misc_strdup(FSDUMP_PART_RAMDISK);
+		if (dump->ramdisk == NULL)
 			return -1;
-		dump_fs->ramdisk_addr = UNSPECIFIED_ADDRESS;
+		dump->ramdisk_addr = UNSPECIFIED_ADDRESS;
 	}
 
-	dump_fs->parm_addr = UNSPECIFIED_ADDRESS;
-	return finalize_dump_fs_address_data(dump_fs, name);
+	dump->parm_addr = UNSPECIFIED_ADDRESS;
+	return finalize_dump_address_data(dump, name);
 }
 
 
@@ -921,13 +904,6 @@ check_job_menu_data(struct job_menu_data
 			if (rc)
 				return rc;
 			break;
-		case job_dump_fs:
-			rc = check_job_dump_fs_data(
-					&menu->entry[i].data.dump_fs,
-					menu->entry[i].name);
-			if (rc)
-				return rc;
-			break;
 		case job_print_usage:
 		case job_print_version:
 		case job_segment:
@@ -1086,9 +1062,6 @@ check_job_data(struct job_data* job)
 	case job_dump_partition:
 		rc = check_job_dump_data(&job->data.dump, job->name);
 		break;
-	case job_dump_fs:
-		rc = check_job_dump_fs_data(&job->data.dump_fs, job->name);
-		break;
 	case job_ipl_tape:
 		rc = check_job_ipl_tape_data(&job->data.ipl_tape, job->name);
 		break;
@@ -1270,10 +1243,10 @@ type_from_target(char *target, disk_type
 		*type = disk_type_fba;
 		return 0;
 	case target_type_ldl:
-		*type = disk_type_eckd_classic;
+		*type = disk_type_eckd_ldl;
 		return 0;
 	case target_type_cdl:
-		*type = disk_type_eckd_compatible;
+		*type = disk_type_eckd_cdl;
 		return 0;
 	default:
 		return -1;
@@ -1351,6 +1324,17 @@ get_job_from_section_data(char* data[],
 					UNSPECIFIED_ADDRESS;
 			}
 		}
+		/* Fill in kdump */
+		if (data[(int) scan_keyword_kdump] != NULL) {
+			if (strcmp(data[(int) scan_keyword_kdump],
+				   "auto") == 0) {
+				job->data.ipl.is_kdump = 1;
+			} else {
+				error_reason("Invalid kdump setting '%s'",
+					     data[(int) scan_keyword_kdump]);
+				return -1;
+			}
+		}
 		break;
 	case section_ipl_tape:
 		/* Tape IPL job */
@@ -1420,46 +1404,14 @@ get_job_from_section_data(char* data[],
 			job->data.dump.mem =
 				(job->data.dump.mem + MEGABYTE_MASK) &
 					~MEGABYTE_MASK;
-			printf("Setting dump size limit to %lldMB\n",
+			printf("Found specification of dump size limit "
+			       "to %lldMB\n",
 			       (unsigned long long) job->data.dump.mem /
 			       		(1024LL * 1024LL));
 		}
 		else
 			job->data.dump.mem = -1LL;
 		break;
-	case section_dumpfs:
-		/* DUMP TO FILESYSTEM job */
-		job->id = job_dump_fs;
-		/* Fill in name of bootmap directory */
-		job->target.bootmap_dir =
-			misc_strdup(data[(int) scan_keyword_target]);
-		if (job->target.bootmap_dir == NULL)
-			return -1;
-		/* Fill in partition name */
-		job->data.dump_fs.partition =
-			misc_strdup(data[(int) scan_keyword_dumptofs]);
-		if (job->data.dump_fs.partition == NULL)
-			return -1;
-		/* Check for mem size specification */
-		if (extract_memsize(job->data.dump_fs.partition,
-				    &job->data.dump_fs.mem) == 0) {
-			/* Ensure megabyte alignment of size */
-			job->data.dump_fs.mem =
-				(job->data.dump_fs.mem + MEGABYTE_MASK) &
-					~MEGABYTE_MASK;
-			printf("Setting dump size limit to %lldMB\n",
-			       (unsigned long long) job->data.dump_fs.mem /
-			       		(1024LL * 1024LL));
-		} else
-			job->data.dump_fs.mem = -1LL;
-		/* Fill in parmline */
-		rc = get_parmline(data[(int) scan_keyword_parmfile],
-				  data[(int) scan_keyword_parameters],
-				  &job->data.dump_fs.parmline,
-				  &job->data.dump_fs.parm_addr, section);
-		if (rc)
-			return rc;
-		break;
 	case section_mvdump:
 		/* DUMP TO MULTI-VOLUME job */
 		job->id = job_mvdump;
@@ -1475,7 +1427,8 @@ get_job_from_section_data(char* data[],
 			job->data.mvdump.mem =
 				(job->data.mvdump.mem + MEGABYTE_MASK) &
 					~MEGABYTE_MASK;
-			printf("Setting dump size limit to %lldMB\n",
+			printf("Found specification of dump size limit "
+			       "to %lldMB\n",
 			       (unsigned long long) job->data.mvdump.mem /
 			       		(1024LL * 1024LL));
 		} else
@@ -1643,13 +1596,6 @@ get_menu_job(struct scan_token* scan, ch
 				memset((void *) &temp_job->data.ipl, 0,
 				       sizeof(struct job_ipl_data));
 				break;
-			case job_dump_fs:
-				job->data.menu.entry[current].id = job_dump_fs;
-				job->data.menu.entry[current].data.dump_fs =
-					temp_job->data.dump_fs;
-				memset((void *) &temp_job->data.dump_fs, 0,
-				       sizeof(struct job_dump_fs_data));
-				break;
 			default:
 				error_reason("Section '%s' cannot be included "
 					     "in menu '%s'", section, menu);
@@ -1760,19 +1706,6 @@ get_section_job(struct scan_token* scan,
 			if (buffer == NULL)
 				return -1;
 			break;
-		case job_dump_fs:
-			if (job->data.dump_fs.parmline == NULL)
-				buffer = misc_strdup(extra_parmline);
-			else {
-				buffer = append_parmline(
-					job->data.dump_fs.parmline,
-					extra_parmline);
-				free(job->data.dump_fs.parmline);
-			}
-			job->data.dump_fs.parmline = buffer;
-			if (buffer == NULL)
-				return -1;
-			break;
 		case job_segment:
 			error_reason("Option 'parameters' cannot be used with "
 				     "section '%s'", section);
--- a/zipl/src/misc.c
+++ b/zipl/src/misc.c
@@ -7,6 +7,7 @@
  * Author(s): Carsten Otte <cotte@de.ibm.com>
  *            Peter Oberparleiter <Peter.Oberparleiter@de.ibm.com>
  */
+#define _GNU_SOURCE /* for asprintf */
 
 #include "misc.h"
 
@@ -18,6 +19,7 @@
 #include <string.h>
 #include <stdlib.h>
 #include <stdio.h>
+#include <stdarg.h>
 
 #include "error.h"
 
@@ -38,6 +40,21 @@ misc_malloc(size_t size)
 }
 
 
+/* asprintf with misc error checking */
+int misc_asprintf(char** out, const char* fmt, ...)
+{
+	va_list ap;
+	int rc;
+
+	va_start(ap, fmt);
+	rc = vasprintf(out, fmt, ap);
+	va_end(ap);
+	if (rc == -1)
+		error_reason("Could not allocate space for new string");
+	return rc;
+}
+
+
 /* Allocate N * SIZE bytes of memory. Upon success, return pointer to memory.
  * Return NULL otherwise. */
 void *
@@ -71,6 +88,21 @@ misc_strdup(const char* s)
 }
 
 
+/* Open file exclusive */
+int
+misc_open_exclusive(const char* filename)
+{
+	int fd;
+
+	fd = open(filename, O_RDWR | O_EXCL);
+	if (fd == -1 && errno == EBUSY)
+		error_reason("Device is in use (probably mounted)");
+	else if (fd == -1)
+		error_reason(strerror(errno));
+	return fd;
+}
+
+
 /* Read COUNT bytes of data from file identified by file descriptor FD to
  * memory at location BUFFER. Return 0 when all bytes were successfully read,
  * non-zero otherwise. */
@@ -350,16 +382,33 @@ misc_write(int fd, const void* data, siz
 		rc = write(fd, VOID_ADD(data, written), count - written);
 		if (rc == -1) {
 			error_reason(strerror(errno));
+			error_text("Could not write to device");
 			return -1;
 		}
 		if (rc == 0) {
 			error_reason("Write failed");
+			error_text("Could not write to device");
 			return -1;
 		}
 	}
 	return 0;
 }
 
+int misc_seek(int fd, off_t off)
+{
+	if (lseek(fd, off, SEEK_SET) == off)
+		return 0;
+	error_reason(strerror(errno));
+	error_text("Could not seek on device");
+	return -1;
+}
+
+int misc_pwrite(int fd, void *buf, size_t size, off_t off)
+{
+	if (misc_seek(fd, off))
+		return -1;
+	return misc_write(fd, buf, size);
+}
 
 int
 misc_check_writable_directory(const char* directory)
@@ -436,3 +485,123 @@ misc_check_writable_device(const char* d
 }
 
 
+
+/* ASCII to EBCDIC conversion table. */
+unsigned char ascebc[256] =
+{
+	0x00, 0x01, 0x02, 0x03, 0x37, 0x2D, 0x2E, 0x2F,
+	0x16, 0x05, 0x15, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
+	0x10, 0x11, 0x12, 0x13, 0x3C, 0x3D, 0x32, 0x26,
+	0x18, 0x19, 0x3F, 0x27, 0x22, 0x1D, 0x1E, 0x1F,
+	0x40, 0x5A, 0x7F, 0x7B, 0x5B, 0x6C, 0x50, 0x7D,
+	0x4D, 0x5D, 0x5C, 0x4E, 0x6B, 0x60, 0x4B, 0x61,
+	0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7,
+	0xF8, 0xF9, 0x7A, 0x5E, 0x4C, 0x7E, 0x6E, 0x6F,
+	0x7C, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7,
+	0xC8, 0xC9, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6,
+	0xD7, 0xD8, 0xD9, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6,
+	0xE7, 0xE8, 0xE9, 0xBA, 0xE0, 0xBB, 0xB0, 0x6D,
+	0x79, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
+	0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96,
+	0x97, 0x98, 0x99, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6,
+	0xA7, 0xA8, 0xA9, 0xC0, 0x4F, 0xD0, 0xA1, 0x07,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x59, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
+	0x90, 0x3F, 0x3F, 0x3F, 0x3F, 0xEA, 0x3F, 0xFF
+};
+
+/* EBCDIC to ASCII conversion table. */
+unsigned char ebcasc[256] =
+{
+/* 0x00  NUL   SOH   STX   ETX  *SEL    HT  *RNL   DEL */
+	0x00, 0x01, 0x02, 0x03, 0x07, 0x09, 0x07, 0x7F,
+/* 0x08  -GE  -SPS  -RPT    VT    FF    CR    SO    SI */
+	0x07, 0x07, 0x07, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
+/* 0x10  DLE   DC1   DC2   DC3  -RES   -NL    BS  -POC */
+	0x10, 0x11, 0x12, 0x13, 0x07, 0x0A, 0x08, 0x07,
+/* 0x18  CAN    EM  -UBS  -CU1  -IFS  -IGS  -IRS  -ITB */
+	0x18, 0x19, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
+/* 0x20  -DS  -SOS    FS  -WUS  -BYP    LF   ETB   ESC */
+	0x07, 0x07, 0x1C, 0x07, 0x07, 0x0A, 0x17, 0x1B,
+/* 0x28  -SA  -SFE   -SM  -CSP  -MFA   ENQ   ACK   BEL */
+	0x07, 0x07, 0x07, 0x07, 0x07, 0x05, 0x06, 0x07,
+/* 0x30 ----  ----   SYN   -IR   -PP  -TRN  -NBS   EOT */
+	0x07, 0x07, 0x16, 0x07, 0x07, 0x07, 0x07, 0x04,
+/* 0x38 -SBS   -IT  -RFF  -CU3   DC4   NAK  ----   SUB */
+	0x07, 0x07, 0x07, 0x07, 0x14, 0x15, 0x07, 0x1A,
+/* 0x40   SP   RSP           ?              ----       */
+	0x20, 0xFF, 0x83, 0x84, 0x85, 0xA0, 0x07, 0x86,
+/* 0x48                      .     <     (     +     | */
+	0x87, 0xA4, 0x9B, 0x2E, 0x3C, 0x28, 0x2B, 0x7C,
+/* 0x50    &                                      ---- */
+	0x26, 0x82, 0x88, 0x89, 0x8A, 0xA1, 0x8C, 0x07,
+/* 0x58          ?     !     $     *     )     ;       */
+	0x8D, 0xE1, 0x21, 0x24, 0x2A, 0x29, 0x3B, 0xAA,
+/* 0x60    -     /  ----     ?  ----  ----  ----       */
+	0x2D, 0x2F, 0x07, 0x8E, 0x07, 0x07, 0x07, 0x8F,
+/* 0x68             ----     ,     %     _     >     ? */
+	0x80, 0xA5, 0x07, 0x2C, 0x25, 0x5F, 0x3E, 0x3F,
+/* 0x70  ---        ----  ----  ----  ----  ----  ---- */
+	0x07, 0x90, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
+/* 0x78    *     `     :     #     @     '     =     " */
+	0x70, 0x60, 0x3A, 0x23, 0x40, 0x27, 0x3D, 0x22,
+/* 0x80    *     a     b     c     d     e     f     g */
+	0x07, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67,
+/* 0x88    h     i              ----  ----  ----       */
+	0x68, 0x69, 0xAE, 0xAF, 0x07, 0x07, 0x07, 0xF1,
+/* 0x90    ?     j     k     l     m     n     o     p */
+	0xF8, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, 0x70,
+/* 0x98    q     r                    ----        ---- */
+	0x71, 0x72, 0xA6, 0xA7, 0x91, 0x07, 0x92, 0x07,
+/* 0xA0          ~     s     t     u     v     w     x */
+	0xE6, 0x7E, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
+/* 0xA8    y     z              ----  ----  ----  ---- */
+	0x79, 0x7A, 0xAD, 0xAB, 0x07, 0x07, 0x07, 0x07,
+/* 0xB0    ^                    ----     ?  ----       */
+	0x5E, 0x9C, 0x9D, 0xFA, 0x07, 0x07, 0x07, 0xAC,
+/* 0xB8       ----     [     ]  ----  ----  ----  ---- */
+	0xAB, 0x07, 0x5B, 0x5D, 0x07, 0x07, 0x07, 0x07,
+/* 0xC0    {     A     B     C     D     E     F     G */
+	0x7B, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47,
+/* 0xC8    H     I  ----           ?              ---- */
+	0x48, 0x49, 0x07, 0x93, 0x94, 0x95, 0xA2, 0x07,
+/* 0xD0    }     J     K     L     M     N     O     P */
+	0x7D, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, 0x50,
+/* 0xD8    Q     R  ----           ?                   */
+	0x51, 0x52, 0x07, 0x96, 0x81, 0x97, 0xA3, 0x98,
+/* 0xE0    \           S     T     U     V     W     X */
+	0x5C, 0xF6, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
+/* 0xE8    Y     Z        ----     ?  ----  ----  ---- */
+	0x59, 0x5A, 0xFD, 0x07, 0x99, 0x07, 0x07, 0x07,
+/* 0xF0    0     1     2     3     4     5     6     7 */
+	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
+/* 0xF8    8     9  ----  ----     ?  ----  ----  ---- */
+	0x38, 0x39, 0x07, 0x07, 0x9A, 0x07, 0x07, 0x07
+};
+
+void misc_ebcdic_to_ascii(unsigned char *from, unsigned char *to)
+{
+	for (; from != to; from++)
+		*from = ebcasc[*from];
+}
+
+void misc_ascii_to_ebcdic(unsigned char *from, unsigned char *to)
+{
+	for (; from != to; from++)
+		*from = ascebc[*from];
+}
+
+
--- a/zipl/src/scan.c
+++ b/zipl/src/scan.c
@@ -33,45 +33,45 @@ enum scan_key_state scan_key_table[SCAN_
  *	 ult  to   tofs e    mete file isk  ent  et   pt   out  ultm      dump
  *			     rs                                 enu
  *
- *       targ targ targ targ targ defa
- *       etba etty etge etbl etof ulta
+ *       targ targ targ targ targ defa kdum
+ *       etba etty etge etbl etof ulta p
  *       se   pe   omet ocks fset uto
  *                 ry   ize
  */
 /* default auto */
 	{opt, inv, inv, inv, inv, inv, inv, inv, req, opt, opt, inv, inv, inv,
-	 opt, opt, opt, opt, opt, opt},
+	 opt, opt, opt, opt, opt, opt, inv},
 /* default menu */
 	{inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, req, inv, inv,
-	 inv, inv, inv, inv, inv, inv},
+	 inv, inv, inv, inv, inv, inv, inv},
 /* default section */
 	{req, inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, inv,
-	 inv, inv, inv, inv, inv, inv},
+	 inv, inv, inv, inv, inv, inv, inv},
 /* ipl		*/
 	{inv, inv, inv, req, opt, opt, opt, inv, req, inv, inv, inv, inv, inv,
-	 opt, opt, opt, opt, opt, inv},
+	 opt, opt, opt, opt, opt, inv, opt},
 /* segment load */
 	{inv, inv, inv, inv, inv, inv, inv, req, req, inv, inv, inv, inv, inv,
-	 inv, inv, inv, inv, inv, inv},
+	 inv, inv, inv, inv, inv, inv, inv},
 /* part dump	*/
 	{inv, req, inv, inv, inv, inv, inv, inv, opt, inv, inv, inv, inv, inv,
-	 inv, inv, inv, inv, inv, inv},
+	 inv, inv, inv, inv, inv, inv, inv},
 /* fs dump	*/
 	{inv, inv, req, inv, opt, opt, inv, inv, req, inv, inv, inv, inv, inv,
-	 inv, inv, inv, inv, inv, inv},
+	 inv, inv, inv, inv, inv, inv, inv},
 /* ipl tape	*/
 	{inv, inv, inv, req, opt, opt, opt, inv, inv, inv, inv, inv, req, inv,
-	 inv, inv, inv, inv, inv, inv},
+	 inv, inv, inv, inv, inv, inv, inv},
 /* multi volume dump	*/
 	{inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, inv, req,
-	 inv, inv, inv, inv, inv, inv}
+	 inv, inv, inv, inv, inv, inv, inv}
 };
 
 /* Determines which keyword may be present in a menu section */
 enum scan_key_state scan_menu_key_table[SCAN_KEYWORD_NUM] = {
 /* menu section */
 	 opt, inv, inv, inv, inv, inv, inv, inv, req, opt, opt, inv, inv, inv,
-	 opt, opt, opt, opt, opt, inv
+	 opt, opt, opt, opt, opt, inv, inv
 };
 
 /* Mapping of keyword IDs to strings */
@@ -97,7 +97,8 @@ static const struct {
 	{ "target", scan_keyword_target},
 	{ "prompt", scan_keyword_prompt},
 	{ "timeout", scan_keyword_timeout},
-	{ "tape", scan_keyword_tape}
+	{ "tape", scan_keyword_tape},
+	{ "kdump", scan_keyword_kdump},
 };
 
 /* List of keywords that are used without an assignment */
@@ -701,8 +702,6 @@ scan_get_target_type(char *type)
 	return target_type_invalid;
 }
 
-#define MAX(a,b)	((a)>(b)?(a):(b))
-
 /* Check section data for correctness. KEYWORD[keyword_id] defines whether
  * a keyword is present, LINE[keyword_id] specifies in which line a keyword
  * was found or NULL when specified on command line, NAME specifies the
@@ -730,8 +729,9 @@ scan_check_section_data(char* keyword[],
 			*type = section_dump;
 			main_keyword = scan_keyword_name(scan_keyword_dumpto);
 		} else if (keyword[(int) scan_keyword_dumptofs]) {
-			*type = section_dumpfs;
-			main_keyword = scan_keyword_name(scan_keyword_dumptofs);
+			error_reason("Option dumptofs is deprecated, "
+				     "use dumpto instead");
+			return -1;
 		} else if (keyword[(int) scan_keyword_mvdump]) {
 			*type = section_mvdump;
 			main_keyword = scan_keyword_name(scan_keyword_mvdump);
--- a/zipl/src/zipl.c
+++ b/zipl/src/zipl.c
@@ -1,8 +1,7 @@
 /*
- * s390-tools/zipl/src/zipl.c
- *   zSeries Initial Program Loader tool.
+ * zipl - zSeries Initial Program Loader tool
  *
- * Copyright IBM Corp. 2001, 2009.
+ * Copyright IBM Corp. 2001, 2014
  *
  * Author(s): Carsten Otte <cotte@de.ibm.com>
  *            Peter Oberparleiter <Peter.Oberparleiter@de.ibm.com>
@@ -41,7 +40,7 @@ int dry_run = 1;
 static const char tool_name[] = "zipl: zSeries Initial Program Loader";
 
 /* Copyright notice */
-static const char copyright_notice[] = "Copyright IBM Corp. 2001, 2009";
+static const char copyright_notice[] = "Copyright IBM Corp. 2001, 2014";
 
 /* Usage information */
 static const char* usage_text[] = {
@@ -72,8 +71,6 @@ static const char* usage_text[] = {
 "                                disk partition listed in file DEVLIST",
 "-f, --force                     Disable sanity check while producing a",
 "                                multi-volume dump",
-"-D, --dumptofs DUMPDEV[,SIZE]   Install a system dump record for dumping to",
-"                                filesystem on partition identified by DUMPDEV",
 "-m, --menu MENU                 Install multi-boot configuration MENU",
 "-n, --noninteractive            Answer all confirmation questions with 'yes'",
 "-V, --verbose                   Provide more verbose output",
@@ -120,9 +117,8 @@ int
 main(int argc, char* argv[])
 {
 	struct disk_info* info;
-	disk_blockptr_t program_table;
-	disk_blockptr_t* stage2_list;
-	blocknum_t stage2_count;
+	disk_blockptr_t program_table, scsi_dump_sb_blockptr, *stage1b_list;
+	blocknum_t stage1b_count;
 	struct job_data* job;
 	char* device;
 	int rc;
@@ -167,21 +163,40 @@ main(int argc, char* argv[])
 	umask(077);
 	/* Do it */
 	switch (job->id) {
+	case job_dump_partition:
+		if (disk_is_tape(job->data.dump.device) ||
+		    !disk_is_scsi(job->data.dump.device, &job->target)) {
+			rc = install_dump(job->data.dump.device, &job->target,
+					  job->data.dump.mem);
+			break;
+		}
+		/* Dump to a raw SCSI partition */
+		if (job->data.dump.mem != -1uLL) {
+			error_reason("Dump size can not be limited for "
+				     "partition dump on a SCSI disk");
+			rc = -1;
+			break;
+		}
+		rc = check_job_dump_images(&job->data.dump, job->name);
+		if (rc != 0)
+			break;
+		/* Fall through. */
 	case job_ipl:
 	case job_segment:
-	case job_dump_fs:
 	case job_menu:
 		/* Create bootmap */
-		stage2_list = NULL;
-		rc = bootmap_create(job, &program_table, &stage2_list,
-				    &stage2_count, &device, &info);
+		stage1b_list = NULL;
+		rc = bootmap_create(job, &program_table, &scsi_dump_sb_blockptr,
+				    &stage1b_list, &stage1b_count, &device,
+				    &info);
 		if (rc)
 			break;
 		/* Install boot loader */
 		rc = install_bootloader(device, &program_table,
-					stage2_list, stage2_count, info, job);
-		if (stage2_list != NULL)
-			free(stage2_list);
+					&scsi_dump_sb_blockptr, stage1b_list,
+					stage1b_count, info, job);
+		if (stage1b_list != NULL)
+			free(stage1b_list);
 		misc_free_temp_dev(device);
 		disk_free_info(info);
 		break;
@@ -194,11 +209,6 @@ main(int argc, char* argv[])
 					job->data.ipl_tape.parm_addr,
 					job->data.ipl_tape.ramdisk_addr);
 		break;
-	case job_dump_partition:
-		/* Retrieve target device information */
-		rc = install_dump(job->data.dump.device, &job->target,
-				  job->data.dump.mem);
-		break;
 	case job_mvdump:
 		rc = install_mvdump(job->data.mvdump.device,
 				    &job->target,
--- a/zipl/src/zipl_helper.device-mapper
+++ b/zipl/src/zipl_helper.device-mapper
@@ -9,17 +9,18 @@
 # Depending on the name by which the script is called, it serves one of two
 # purposes:
 #
-# 1. Usage: zipl_helper.device-mapper <target directory>
+# 1. Usage: zipl_helper.device-mapper <target directory> or
+#                                     <major:minor of target device>
 #
-# This tool attempts to obtain zipl parameters for a target directory located
-# on a device-mapper device. It assumes that the device-mapper table for this
-# device conforms to the following rules:
+# This tool attempts to obtain zipl parameters for a target directory or
+# partition located on a device-mapper device. It assumes that the
+# device-mapper table for this device conforms to the following rules:
 # - directory is located on a device consisting of a single device-mapper
 #   target
 # - only linear, mirror and multipath targets are supported
 # - supported physical device types are DASD and SCSI devices
 # - all of the device which contains the directory must be located on a single
-#   physical device (which may be mirrorred or accessed through a multipath
+#   physical device (which may be mirrored or accessed through a multipath
 #   target)
 # - any mirror in the device-mapper setup must include block 0 of the
 #   physical device
@@ -94,6 +95,7 @@ sub get_type_name($);
 sub check_for_mirror($@);
 sub get_target_base($$$$@);
 sub get_device_name($$);
+sub check_tools();
 
 my $phy_geometry;	# Disk geometry of physical device
 my $phy_blocksize;	# Blocksize of physical device
@@ -132,12 +134,24 @@ if ($toolname eq "chreipl_helper.device-
 
 $directory = $ARGV[0];
 if (!defined($directory)) {
-	die("Usage: $toolname <target directory>\n");
+	die("Usage: $toolname <target directory> or <major:minor of target devies>\n");
+}
+
+# check if needed tools are available
+check_tools();
+
+if (($ARGV[0] =~ /^\s*(\d+)\s*:\s*(\d+)\s*$/)) {
+    	# Determine physical (non-dm) device on which partition is located
+	($phy_major, $phy_minor, $phy_offset, @target_list) =
+		get_physical_device($1,$2);
+}
+else
+{
+	# Determine physical (non-dm) device on which directory is located
+	($phy_major, $phy_minor, $phy_offset, @target_list) =
+		get_physical_device_dir($directory);
 }
 
-# Determine physical (non-dm) device on which directory is located
-($phy_major, $phy_minor, $phy_offset, @target_list) =
-	get_physical_device_dir($directory);
 # Determine type and characteristics of physical device
 ($phy_type, $phy_blocksize, $phy_geometry, $phy_bootsectors, $phy_partstart) =
 	get_device_characteristics($phy_major, $phy_minor);
@@ -753,3 +767,17 @@ sub get_device_name($$)
 out:
 	return $name;
 }
+
+sub check_tools()
+{
+system("$dmsetup --version &> /dev/null") >> 8 != 127
+    or die("Error: dmsetup not found\n");
+system("$mknod --version &> /dev/null") >> 8 != 127
+    or die("Error: mknod not found\n");
+system("$dasdview --version &> /dev/null") >> 8 != 127
+    or die("Error: dasdview not found\n");
+system("$blockdev --version &> /dev/null") >> 8 != 127
+    or die("Error: blockdev not found\n");
+
+return 0;
+}
